/*
 * Copyright 2010 the original author or authors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 * Contains the framework's built-in combine-strategies as well as their API,
 * which can be used to develop customized combine-strategies. <br/><br/>
 * This is the root package of the "combine sub-framework", which is completly
 * unaware of the rest of the CallbackParams' framework. Thus its combinatory
 * features can easily be utilized on their own, without involving the rest
 * of the framework.<br/>
 * It is upon the integration functionality (e.g. the JUnit-integration provided
 * by
 * {@link org.callbackparams.junit4.CallbackParamsRunner CallbackParamsRunner})
 * to make sure the combine-functionality is as seamlessly available
 * as possible to the test-developer. The integration APIs are recommended to
 * recognize and push the annotation
 * {@link org.callbackparams.combine.annotation.CombineConfig @CombineConfig}
 * as the developer's best practise to specify and configure a combine-strategy.
 *
 * @see org.callbackparams.combine.annotation.CombineConfig @CombineConfig
 */
package org.callbackparams.combine;
